// Code generated by mockery v2.53.0. DO NOT EDIT.

package membership

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	db "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/db"

	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockService is an autogenerated mock type for the Service type
type MockService struct {
	mock.Mock
}

// CreateGlobalMembership provides a mock function with given fields: ctx, input
func (_m *MockService) CreateGlobalMembership(ctx context.Context, input *CreateGlobalMembershipInput) (*models.Membership, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateGlobalMembership")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreateGlobalMembershipInput) (*models.Membership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreateGlobalMembershipInput) *models.Membership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreateGlobalMembershipInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateOrganizationMembership provides a mock function with given fields: ctx, input
func (_m *MockService) CreateOrganizationMembership(ctx context.Context, input *CreateOrganizationMembershipInput) (*models.Membership, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateOrganizationMembership")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreateOrganizationMembershipInput) (*models.Membership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreateOrganizationMembershipInput) *models.Membership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreateOrganizationMembershipInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateProjectMembership provides a mock function with given fields: ctx, input
func (_m *MockService) CreateProjectMembership(ctx context.Context, input *CreateProjectMembershipInput) (*models.Membership, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateProjectMembership")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreateProjectMembershipInput) (*models.Membership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreateProjectMembershipInput) *models.Membership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreateProjectMembershipInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteMembership provides a mock function with given fields: ctx, input
func (_m *MockService) DeleteMembership(ctx context.Context, input *DeleteMembershipInput) error {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for DeleteMembership")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *DeleteMembershipInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetMembershipByID provides a mock function with given fields: ctx, id
func (_m *MockService) GetMembershipByID(ctx context.Context, id string) (*models.Membership, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetMembershipByID")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Membership, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Membership); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMembershipByPRN provides a mock function with given fields: ctx, prn
func (_m *MockService) GetMembershipByPRN(ctx context.Context, prn string) (*models.Membership, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetMembershipByPRN")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Membership, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Membership); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMemberships provides a mock function with given fields: ctx, input
func (_m *MockService) GetMemberships(ctx context.Context, input *GetMembershipsInput) (*db.MembershipsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetMemberships")
	}

	var r0 *db.MembershipsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetMembershipsInput) (*db.MembershipsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetMembershipsInput) *db.MembershipsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*db.MembershipsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetMembershipsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMembershipsByIDs provides a mock function with given fields: ctx, idList
func (_m *MockService) GetMembershipsByIDs(ctx context.Context, idList []string) ([]models.Membership, error) {
	ret := _m.Called(ctx, idList)

	if len(ret) == 0 {
		panic("no return value specified for GetMembershipsByIDs")
	}

	var r0 []models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, []string) ([]models.Membership, error)); ok {
		return rf(ctx, idList)
	}
	if rf, ok := ret.Get(0).(func(context.Context, []string) []models.Membership); ok {
		r0 = rf(ctx, idList)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, []string) error); ok {
		r1 = rf(ctx, idList)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateMembership provides a mock function with given fields: ctx, input
func (_m *MockService) UpdateMembership(ctx context.Context, input *UpdateMembershipInput) (*models.Membership, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for UpdateMembership")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *UpdateMembershipInput) (*models.Membership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *UpdateMembershipInput) *models.Membership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *UpdateMembershipInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockService creates a new instance of MockService. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockService(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockService {
	mock := &MockService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
